/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


////////////////////////////////////////////////////////////////////////////
//
// Connection Methods
//
////////////////////////////////////////////////////////////////////////////

#include <libc.h>
#include <stdio.h>
#include <strings.h>

#include "oo7.h"
#include "globals.h"
#include "GenParams.h"

extern o_4b	debugMode;
extern char*	types[NumTypes];

Implement PClassObj<Connection>;

////////////////////////////////////////////////////////////////////////////
//
// Connection Constructor
//
////////////////////////////////////////////////////////////////////////////

Connection::Connection(Link<AtomicPart> fromPart, Link<AtomicPart> toPart) :
    from(fromPart), to(toPart)
{
    Link<Connection>	self(this);

    if (debugMode) {
        printf("Connection::Connection(fromId = %d, toId = %d)\n",
            fromPart->id, toPart->id);
    }

    // initialize the simple stuff
    o_4b	typeNo = (o_4b)(random() % NumTypes);

    strncpy(type, types[typeNo], TypeSize);
    length = (o_4b)(random() % XYRange);

    // insert Link to this connection object
    // into appropriate atomic part's "to" list
    (fromPart->to).add(self); 
// JGM 93/11/4 Added next line
    fromPart->dirty();

    // insert Link to this connection object
    // into appropriate atomic part's "from" list
    (toPart->from).add(self); 
// JGM 93/11/4 Added next line
    toPart->dirty();
}
