#include "oo7.h"
#include <cxxcls/try.h>
#include "Iterator.h"

// JGM 93/10/15 changed next line to a prime number
#define BLOCK_SIZE 4091
// #define	BLOCK_SIZE	4096

Iterator::Iterator() :
    curIndex(0), curOffset(0), loadedOffset(0)
{
}

Iterator::~Iterator()
{
    if ( !parts.is_empty() )
	parts.release();
    block.release();
}

void
Iterator::load(void)
{
    // JGM 93/10/15 next few lines unpins the block that was
    // previously group read

    o_4b size = block.size();
    for (o_word i = 0; i < size; i++) {
      block[i]->unpinobj();	// unpin the objects we no longer need
				// Actually, could do this directly in
				// the Queries, but it's easier to do
				// it here
    }

    size = parts.size();

    size -= curOffset;
    if ( size > BLOCK_SIZE )
	size = BLOCK_SIZE;
    if ( size == 0 )
	return;

    // JGM 93/10/15 Since we know the size of the chunk we want to
    // gread(), tell the LinkVstrAny to malloc the space it needs,
    // now.

    block.set_size(size);

    for ( i = 0; i < size; i++ )
	block[i] = parts[curOffset + i];

    o_4b	offset = curOffset - BLOCK_SIZE;


    ::dom->greadobjs(block, NULL);


    if ( loadedOffset == curOffset )
	loadedOffset += BLOCK_SIZE;
    curOffset += BLOCK_SIZE;
}


// JGM 93/10/15 added const to pred argument to keep cfront 3.0 quiet
void
Iterator::select(PartType type, const PPredicate& pred)
{
    if (!parts.is_empty())
	return;
    switch(type)
    {
    case Atomic:
	parts = PClassObject<AtomicPart>::Object().select(NULL, FALSE, pred);
	break;
    case Composite:
	parts = PClassObject<CompositePart>::Object().select(NULL, FALSE, pred);
	break;
    }
    load();
}

LinkAny
Iterator::next(void)
{
    if ( curIndex >= parts.size() )
	return NULL_LINK;
    if ( curIndex >= loadedOffset )
	load();
    return parts[curIndex++];
}
