/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <libc.h>
#include <stdio.h>

#include "oo7.h"
#include "globals.h"
#include "GenParams.h"
#include "BenchParams.h"
#include "VarParams.h"
#include "Iterator.h"

//////////////////////////////////////////////////////////////////
//
// Query #7 --- iterate through all atomic parts.  Checks scan
// speed.  Some duplication with other queries, especially in
// systems that lack indices and force the other queries to be
// done by iterating through sets.
//
//////////////////////////////////////////////////////////////////

extern o_4b	debugMode;

static Iterator	partI;

//////////////////////////////////////////////////////////////////
//
// Routine to do Query #7
//
//////////////////////////////////////////////////////////////////

o_4b query7()
{
    AtomicPart*	part;
    o_4b	count = 0;

    partI.select(Atomic, NULL_PREDICATE);
    for (part = (Link<AtomicPart>)partI.first(); part != NULL;
	 part = (Link<AtomicPart>)partI.next()) {
        if (debugMode) {
            printf("    In Query7, partId = %d:\n", part->id);
        }

	part->DoNothing();
        count++;
    }
    return count;
}
