/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <libc.h>
#include <string.h>
#include <stdio.h>

#include "oo7.h"
#include "globals.h"
#include "GenParams.h"
#include "BenchParams.h"
#include "VarParams.h"
#include "Iterator.h"
#include "Index.h"
#include <cxxcls/vdiction.h>

//////////////////////////////////////////////////////////////////
//
// Query #8 --- value join between Documents and AtomicParts
// on Document.id and AtomicPart.docId. 
//
//
//////////////////////////////////////////////////////////////////

extern o_4b	debugMode;
extern void	JoinDoNothing(o_4b x, o_4b y);

extern Link<VEIDictionary<o_4b, Document> >	documentIndex;

static Iterator	partI;

//////////////////////////////////////////////////////////////////
//
// Routine to do Query #8
//
//////////////////////////////////////////////////////////////////

o_4b query8()
{
    Index	docIndex("document index");
    AtomicPart*	part;
    o_4b	count = 0;

    documentIndex = docIndex.getIndex();
    partI.select(Atomic, NULL_PREDICATE);
    for (part = (Link<AtomicPart>)partI.first(); part != NULL;
	 part = (Link<AtomicPart>)partI.next()) {
	Document*	document = &(*documentIndex)[part->docId];

	if ( document != NULL )
	{
	   // found a matching pair of tuples
           if (debugMode) 
		printf("In Query8, atomic part %d matches doc %d.\n",
			part->id, document->id);
	   JoinDoNothing(part->id, document->id);
	   count++;
    	}
   }
   return count;
}
